
package Convolve;

# package for convolution

use fields qw(ft);

use PDL;
use PDL::FFTW;

sub new {
  my $class = shift;

  no strict 'refs';
  my $self = bless [\%{"$class\::FIELDS"}], $class;
  use strict 'refs';

  my $image = shift;
  my @dims = $image->dims();
  $self->{ft} = rfftw($image) / ($dims[0]*$dims[1]);

  $self;
}

sub convolve {
  my $self = shift;
  my $ft2 = rfftw shift;

  return irfftw Cmul($self->{ft},$ft2);
}


1;
