
package NoiseIt;

# simulates shot and additive noise and supports magnitude calculation

use Exporter;
use PDL;
use PDL::GSL::RNG;

@ISA = ('Exporter');
@EXPORT = qw(phmag Shot AddP AddG);

my $rng;

BEGIN {
  $rng = PDL::GSL::RNG->new('taus');
  $rng->set_seed(time());
}

sub phmag {
  my ($mag,$d,$dt) = @_;

  return int (6.3 * $d * $d * ( 10 ** (7 - $mag/2.5) ) * $dt*100);
}

sub Shot {
  my $im = shift;
  my $ph = shift;

  $im = $im * float ($ph/$im->sum());
  $rng->ran_feed_poisson($im);
  return $im;
}

sub AddG {
  my $im = shift;
  my $sigma = shift;

  $rng->ran_additive_gaussian($sigma,$im);
  return $im;
}

sub AddP {
  my $im = shift;
  my $sigma = shift;

  $rng->ran_additive_poisson($sigma,$im);
}

1;
