
#include <stdio.h>
#include <math.h>

#include "pdlsimple.h"

static int n,m;
static float * dxp;
static float * dxn;
static float * dyp;
static float * dyn;
static float * out;
static char * done;

static int bsmode=0;

#define A(i,j) ((i)+(j)*n)
#define AA(i,j) (2*(i)+2*(j)*n)
#define AR(v,i,j) v[(2*(i)+2*(j)*n)]
#define AI(v,i,j) v[(1+2*(i)+2*(j)*n)]

#define CMUL(or,oi,ar,ai,br,bi) or=(ar)*(br)-(ai)*(bi); oi=(ar)*(bi)+(ai)*(br);
#define CBMUL(or,oi,ar,ai) {float tr=(or), ti=(oi); or=(ar)*(tr)-(ai)*(ti); oi=(ar)*(ti)+(ai)*(tr);}

void calc_phase1(int i, int j, float *re, float *im) {
  float t;
  int c = A(i,j),cc = AA(i,j);
  float tre, tim, tre1, tim1;
  double modu;

  if (done[c]==1) {
    *re = out[cc];
    *im = out[cc+1];
    return;
  }
  if (i==0 && j==0) {
    tre = 1.0;
    tim = 0;
  }
  else if (bsmode && ( (i==0 && j==1) || (i==0 && j==(m-1)) || (i==1 && j==0) || (i==(n-1) && j==0) ) ) {
    /* for the bispectrum case */
    tre = 1.0;
    tim = 0;
  }
  else if (j==0 && i<(n/2)) {
    /* t = calc_phase(i-1,0) + dxp[c]; */
    calc_phase1(i-1,0,&tre,&tim);
    CBMUL(tre,tim,dxp[cc],dxp[cc+1]);
  }
  else if (j==0 && i==(n-1)) {
    /* t = calc_phase(0,0) + dxn[c]; */
    calc_phase1(0,0,&tre,&tim);
    CBMUL(tre,tim,dxn[cc],dxn[cc+1]);
  }
  else if (j==0 && i>=(n/2)) {
    /* t = calc_phase(i+1,0) + dyn[c]; */
    calc_phase1(i+1,0,&tre,&tim);
    CBMUL(tre,tim,dxn[cc],dxn[cc+1]);
  }
  else if (i==0 && j<(m/2)) {
    /* t = calc_phase(0,j-1) + dyp[c]; */
    calc_phase1(0,j-1,&tre,&tim);
    CBMUL(tre,tim,dyp[cc],dyp[cc+1]);
  }
  else if (i==0 && j==(m-1)) { 
    /* t = calc_phase(0,0) + dyn[c]; */
    calc_phase1(0,0,&tre,&tim);
    CBMUL(tre,tim,dyn[cc],dyn[cc+1]);
  }
  else if (i==0 && j>=(m/2)) {
    /* t = calc_phase(0,j+1) + dyn[c]; */
    calc_phase1(0,j+1,&tre,&tim);
    CBMUL(tre,tim,dyn[cc],dyn[cc+1]);
  }
  else if (j<(m/2) && i<(n/2)) {
    /* t = (calc_phase(i-1,j) + dxp[c] +
       calc_phase(i,j-1) + dyp[c]) / 2.0; */
    calc_phase1(i-1,j,&tre,&tim);
    calc_phase1(i,j-1,&tre1,&tim1);
    CBMUL(tre,tim,dxp[cc],dxp[cc+1]);
    CBMUL(tre1,tim1,dyp[cc],dyp[cc+1]);
    tre += tre1;
    tim += tim1;
    tre /= 2.0;
    tim /= 2.0;
  }
  else if (j==(m-1) && i<(n/2)) {
    /* t = (calc_phase(i-1,j) + dxp[c] +
       calc_phase(i,0) + dyn[c]) / 2.0; */
    calc_phase1(i-1,j,&tre,&tim);
    calc_phase1(i,0,&tre1,&tim1);
    CBMUL(tre,tim,dxp[cc],dxp[cc+1]);
    CBMUL(tre1,tim1,dyn[cc],dyn[cc+1]);
    tre += tre1;
    tim += tim1;
    tre /= 2.0;
    tim /= 2.0;
  }
  else if (j>=(m/2) && i<(n/2)) {
    /* t = (calc_phase(i-1,j) + dxp[c] +
       calc_phase(i,j+1) + dyn[c]) / 2.0; */
    calc_phase1(i-1,j,&tre,&tim);
    calc_phase1(i,j+1,&tre1,&tim1);
    CBMUL(tre,tim,dxp[cc],dxp[cc+1]);
    CBMUL(tre1,tim1,dyn[cc],dyn[cc+1]);
    tre += tre1;
    tim += tim1;
    tre /= 2.0;
    tim /= 2.0;
  }
  else if (j<(m/2) && i==(n-1)) {
    /* t = (calc_phase(0,j) + dxp[c] +
       calc_phase(i,j-1) + dyp[c]) / 2.0; */
    calc_phase1(0,j,&tre,&tim);
    calc_phase1(i,j-1,&tre1,&tim1);
    CBMUL(tre,tim,dxn[cc],dxn[cc+1]);
    CBMUL(tre1,tim1,dyp[cc],dyp[cc+1]);
    tre += tre1;
    tim += tim1;
    tre /= 2.0;
    tim /= 2.0;
  }
  else if (j==(m-1) && i==(n-1)) {
    /* t = (calc_phase(0,j) + dxp[c] +
       calc_phase(i,0) + dyn[c]) / 2.0; */
    calc_phase1(0,j,&tre,&tim);
    calc_phase1(i,0,&tre1,&tim1);
    CBMUL(tre,tim,dxn[cc],dxn[cc+1]);
    CBMUL(tre1,tim1,dyn[cc],dyn[cc+1]);
    tre += tre1;
    tim += tim1;
    tre /= 2.0;
    tim /= 2.0;
  }
  else if (j>=(m/2) && i==(n-1)) {
    /* t = (calc_phase(0,j) + dxp[c] +
       calc_phase(i,j+1) + dyn[c]) / 2.0; */
    calc_phase1(0,j,&tre,&tim);
    calc_phase1(i,j+1,&tre1,&tim1);
    CBMUL(tre,tim,dxn[cc],dxn[cc+1]);
    CBMUL(tre1,tim1,dyn[cc],dyn[cc+1]);
    tre += tre1;
    tim += tim1;
    tre /= 2.0;
    tim /= 2.0;
  }
  else if (j<(m/2) && i>=(n/2)) {
    /* t = (calc_phase(i+1,j) + dxp[c] +
       calc_phase(i,j-1) + dyp[c]) / 2.0; */
    calc_phase1(i+1,j,&tre,&tim);
    calc_phase1(i,j-1,&tre1,&tim1);
    CBMUL(tre,tim,dxn[cc],dxn[cc+1]);
    CBMUL(tre1,tim1,dyp[cc],dyp[cc+1]);
    tre += tre1;
    tim += tim1;
    tre /= 2.0;
    tim /= 2.0;
  }
  else if (j==(m-1) && i>=(n/2)) {
    /* t = (calc_phase(i+1,j) + dxp[c] +
       calc_phase(i,0) + dyn[c]) / 2.0; */
    calc_phase1(i+1,j,&tre,&tim);
    calc_phase1(i,0,&tre1,&tim1);
    CBMUL(tre,tim,dxn[cc],dxn[cc+1]);
    CBMUL(tre1,tim1,dyn[cc],dyn[cc+1]);
    tre += tre1;
    tim += tim1;
    tre /= 2.0;
    tim /= 2.0;
  }
  else if (j>=(m/2) && i>=(n/2)) {
    /* t = (calc_phase(i+1,j) + dxp[c] +
       calc_phase(i,j+1) + dyn[c]) / 2.0; */
    calc_phase1(i+1,j,&tre,&tim);
    calc_phase1(i,j+1,&tre1,&tim1);
    CBMUL(tre,tim,dxn[cc],dxn[cc+1]);
    CBMUL(tre1,tim1,dyn[cc],dyn[cc+1]);
    tre += tre1;
    tim += tim1;
    tre /= 2.0;
    tim /= 2.0;
  }
  else fprintf(stderr,"Strange Internal Error\n");

  modu = sqrt(tre*tre+tim*tim);
  tre /= modu;
  tim /= modu;

  out[cc] = tre;
  out[cc+1] = tim;
  done[c] = 1;
  *re = tre;
  *im = tim;
}

void phase1(int nargs, pdlsimple **argv) {
  int i,j;
  float it,dummy;
 
  if (nargs!=5) {
    fprintf(stderr,"Call with 4 piddles\n");
    return;
  }
  if (argv[0]->datatype != PDL_F ||
      argv[1]->datatype != PDL_F ||
      argv[2]->datatype != PDL_F ||
      argv[3]->datatype != PDL_F ||
      argv[4]->datatype != PDL_F) {
    fprintf(stderr,"Call with 5 float piddles\n");
    return;
  }
  if (argv[0]->ndims != 3 ||
      argv[1]->ndims != 3 ||
      argv[2]->ndims != 3 ||
      argv[3]->ndims != 3 ||
      argv[4]->ndims != 3) {
    fprintf(stderr,"Only 2D complex piddles\n");
    return;
  }
  if (argv[0]->dims[0] != 2 ||
      argv[1]->dims[0] != 2 ||
      argv[2]->dims[0] != 2 ||
      argv[3]->dims[0] != 2 ||
      argv[4]->dims[0] != 2) {
    fprintf(stderr,"Only 2D piddles\n");
    return;
  }

  n = argv[4]->dims[1];
  m = argv[4]->dims[2];

  dxp = (float *) argv[0]->data;
  dxn = (float *) argv[1]->data;
  dyp = (float *) argv[2]->data;
  dyn = (float *) argv[3]->data;
  out = (float *) argv[4]->data;
  done = (char *) malloc(n*m*sizeof(char));
  for(i=0;i<n;i++) {
    for(j=0;j<m;j++) {
      done[A(i,j)] = 0;
    }
  }

  bsmode = 0;

  for(i=0;i<n;i++) {
    calc_phase1(i,m/2,&dummy,&dummy);
    calc_phase1(i,m/2-1,&dummy,&dummy);
  }
  for(j=0;j<m;j++) {
    calc_phase1(n/2,j,&dummy,&dummy);
    calc_phase1(n/2-1,j,&dummy,&dummy);
  }

  free(done);
}

void phase2(int nargs, pdlsimple **argv) {
  int i,j;
  float it,dummy;

  if (nargs!=5) {
    fprintf(stderr,"Call with 4 piddles\n");
    return;
  }
  if (argv[0]->datatype != PDL_F ||
      argv[1]->datatype != PDL_F ||
      argv[2]->datatype != PDL_F ||
      argv[3]->datatype != PDL_F ||
      argv[4]->datatype != PDL_F) {
    fprintf(stderr,"Call with 5 float piddles\n");
    return;
  }
  if (argv[0]->ndims != 3 ||
      argv[1]->ndims != 3 ||
      argv[2]->ndims != 3 ||
      argv[3]->ndims != 3 ||
      argv[4]->ndims != 3) {
    fprintf(stderr,"Only 2D complex piddles\n");
    return;
  }
  if (argv[0]->dims[0] != 2 ||
      argv[1]->dims[0] != 2 ||
      argv[2]->dims[0] != 2 ||
      argv[3]->dims[0] != 2 ||
      argv[4]->dims[0] != 2) {
    fprintf(stderr,"Only 2D piddles\n");
    return;
  }

  n = argv[4]->dims[1];
  m = argv[4]->dims[2];

  dxp = (float *) argv[0]->data;
  dxn = (float *) argv[1]->data;
  dyp = (float *) argv[2]->data;
  dyn = (float *) argv[3]->data;
  out = (float *) argv[4]->data;
  done = (char *) malloc(n*m*sizeof(char));
  for(i=0;i<n;i++) {
    for(j=0;j<m;j++) {
      done[A(i,j)] = 0;
    }
  }

  bsmode = 1;

  for(i=0;i<n;i++) {
    calc_phase1(i,m/2,&dummy,&dummy);
    calc_phase1(i,m/2-1,&dummy,&dummy);
  }
  for(j=0;j<m;j++) {
    calc_phase1(n/2,j,&dummy,&dummy);
    calc_phase1(n/2-1,j,&dummy,&dummy);
  }

  free(done);
}

