

#ifndef _CONFIG_H
#define _CONFIG_H

#ifndef DEBUG
#define GSL_RANGE_CHECK_OFF 1
#endif

#include <gsl_complex.h>
#include <gsl_matrix.h>
#include <fftw.h>
#include <rfftw.h>

#ifdef DEBUG
#define FFTW_OPTIONS (FFTW_ESTIMATE | FFTW_USE_WISDOM)
#else
#define FFTW_OPTIONS (FFTW_MEASURE | FFTW_USE_WISDOM)
#endif

#ifdef DOUBLE
#define REAL double
#define COMPLEX gsl_complex
#define MATRIX gsl_matrix
#define COMPLEX_MATRIX gsl_matrix_complex
#define MATRIX_ALLOC gsl_matrix_alloc
#define MATRIX_CALLOC gsl_matrix_calloc
#define MATRIX_COMPLEX_CALLOC gsl_matrix_complex_calloc
#define MATRIX_COMPLEX_ALLOC gsl_matrix_complex_alloc
#define MATRIX_COMPLEX_FREE gsl_matrix_complex_free
#define MATRIX_FREE gsl_matrix_free
#define MATRIX_APPLY_IJ gsl_matrix_apply_ij
#define MATRIX_COMPLEX_APPLY_IJ gsl_matrix_complex_apply_ij
#define MATRIX_COMPLEX_APPLY gsl_matrix_complex_apply
#define MATRIX_COMPLEX_KEEP_MOD2 gsl_matrix_complex_keep_mod2
#define MATRIX_COMPLEX_KEEP_MOD gsl_matrix_complex_keep_mod
#define MATRIX_APPLY gsl_matrix_apply
#define MATRIX_COMPLEX_SET gsl_matrix_complex_set
#define MATRIX_COMPLEX_GET gsl_matrix_complex_get
#define MATRIX_SET gsl_matrix_set
#define MATRIX_GET gsl_matrix_get
#define MATRIX_COMPLEX_SCALE gsl_complex_scale
#define MATRIX_COMPLEX_MUL_SCALAR gsl_matrix_complex_mul_scalar
#define MATRIX_MUL_SCALAR gsl_matrix_mul_scalar
#define MATRIX_ADD_SCALAR gsl_matrix_add_scalar
#define MATRIX_ADD gsl_matrix_add
#define MATRIX_ROTATE90 gsl_matrix_rot90
#define MATRIX_ROTATE180 gsl_matrix_rot180
#define MATRIX_ROTATE270 gsl_matrix_rot270
#define MATRIX_ROTATE gsl_matrix_rotate
#define MATRIX_FREE gsl_matrix_free
#define MATRIX_SUM gsl_matrix_sum
#define MATRIX_MINMAX gsl_matrix_minmax
#define MATRIX_CENTROID gsl_matrix_centroid
#define MATRIX_RESCALE gsl_matrix_rescale
#define MATRIX_SUB gsl_matrix_sub
#define MATRIX_MUL gsl_matrix_mul
#define MATRIX_CLONE gsl_matrix_clone
#define DATA_TYPE 5
#endif

#ifdef SINGLE
#define REAL float
#define COMPLEX gsl_complex_float
#define MATRIX gsl_matrix_float
#define COMPLEX_MATRIX gsl_matrix_complex_float
#define MATRIX_ALLOC gsl_matrix_float_alloc
#define MATRIX_CALLOC gsl_matrix_float_calloc
#define MATRIX_FREE gsl_matrix_float_free
#define MATRIX_APPLY_IJ gsl_matrix_float_apply_ij
#define MATRIX_COMPLEX_APPLY_IJ gsl_matrix_complex_float_apply_ij
#define MATRIX_COMPLEX_APPLY gsl_matrix_complex_float_apply
#define MATRIX_APPLY gsl_matrix_float_apply
#define MATRIX_COMPLEX_SET gsl_matrix_complex_float_set
#define MATRIX_COMPLEX_GET gsl_matrix_complex_float_get
#define MATRIX_SET gsl_matrix_float_set
#define MATRIX_GET gsl_matrix_float_get
#define MATRIX_COMPLEX_SCALE gsl_complex_scale
#define MATRIX_COMPLEX_MUL_SCALAR gsl_matrix_complex_float_mul_scalar
#define MATRIX_MUL_SCALAR gsl_matrix_float_mul_scalar
#define MATRIX_COMPLEX_CALLOC gsl_matrix_complex_float_calloc
#define MATRIX_COMPLEX_FREE gsl_matrix_complex_float_free
#define MATRIX_MINMAX gsl_matrix_float_minmax
#define DATA_TYPE 4
#endif

#define MAXL 200
#define MAX_LAYERS 4

#endif
