
#ifndef _GSL_COMPLEX_OP_H
#define _GSL_COMPLEX_OP_H

#include <gsl_complex.h>
#include <math.h>

#define gsl_complex_multiply(a,b) { \
double _shield_t; \
_shield_t= GSL_REAL(a)*GSL_REAL(b) - GSL_IMAG(a)*GSL_IMAG(b); \
GSL_IMAG(a)= GSL_REAL(a)*GSL_IMAG(b) + GSL_IMAG(a)*GSL_REAL(b); \
GSL_REAL(a)=_shield_t; }

#define gsl_complex_multiply_reim(a,re,im) { \
double _shield_t; \
_shield_t= GSL_REAL(a)*re - GSL_IMAG(a)*im; \
GSL_IMAG(a)= GSL_REAL(a)*im + GSL_IMAG(a)*re; \
GSL_REAL(a)=_shield_t; }

#define gsl_complex_scale(a,c) { GSL_REAL(a)*=c; GSL_IMAG(a)*=c; }

#define gsl_complex_conj(a) GSL_IMAG(a)=-GSL_IMAG(a);

#define gsl_complex_divide(a,b) { \
double _shield_t= GSL_REAL(b)*GSL_REAL(b) + GSL_IMAG(b)*GSL_IMAG(b); \
gsl_complex_multiply_reim(a,GSL_REAL(b),-GSL_REAL(b)); \
gsl_complex_scale(a,_shield_t); }
 
#define gsl_complex_add(a,b) GSL_REAL(a)+=GSL_REAL(b); GSL_IMAG(a)+=GSL_IMAG(b);

#define gsl_complex_sub(a,b) GSL_REAL(a)-=GSL_REAL(b); GSL_IMAG(a)-=GSL_IMAG(b);

#define gsl_complex_set_reim(a,r,i) GSL_REAL(a)=r; GSL_IMAG(a)=i;

#define gsl_complex_add_reim(a,r,i) GSL_REAL(a)+=r; GSL_IMAG(a)+=i;

#define gsl_complex_r(a) sqrt( GSL_REAL(a)*GSL_REAL(a)+GSL_IMAG(a)*GSL_IMAG(a) )

#define gsl_complex_fi(a) atan2(GSL_IMAG(a),GSL_REAL(a));

#define gsl_complex_set_rfi(a,r,fi) GSL_REAL(a)=t*cos(fi); GSL_IMAG(b)=t*sin(fi);

#define gsl_complex_exp(a) { \
double _shield_t=exp( GSL_REAL(a) ); \
GSL_REAL(a)=_shield_t*cos( GSL_IMAG(a) ); \
GSL_IMAG(a)=_shield_t*sin( GSL_IMAG(a) ); }


#endif
