
#ifndef _GSL_FFTW_WRAPPER_
#define _GSL_FFTW_WRAPPER_

#include <gsl_matrix_complex_double.h>

#define GSL_FFTW_KEEP 0
#define GSL_FFTW_DESTROY 1

#include <fftw.h>

typedef struct {
  fftwnd_plan *planf;
  fftwnd_plan *planb;
  int index;
  gsl_matrix_complex *matrix;
} gsl_fftw_plan;


void gsl_fftw_init(void);

int gsl_fftw_init_matrix_complex(gsl_matrix_complex *, gsl_fftw_plan *,int);
int gsl_fftw_matrix_complex_forward( gsl_fftw_plan*);
int gsl_fftw_matrix_complex_backward( gsl_fftw_plan*);
int gsl_fftw_matrix_complex_inverse( gsl_fftw_plan*);
int gsl_fftw_free_matrix_complex(gsl_fftw_plan*,int);

#endif
