
int FUNCTION (gsl_matrix, apply) ( TYPE(gsl_matrix) *m, void *f ( BASE * ) ) {
  int i, max= m->size2 * m->size1;
  ATOMIC *p=m->data;
  
  for(i=0;i<max;i++) {
    (*f)( (BASE *) p);
    p+=MULTIPLICITY;
  }
  return GSL_SUCCESS;
}

int FUNCTION (gsl_matrix, apply_arg) ( TYPE(gsl_matrix) *m, void *f ( BASE *, BASE), BASE p1) {
  int i, max= m->size2 * m->size1;
  ATOMIC *p=m->data;
  
  for(i=0;i<max;i++) {
    (*f)((BASE *)p,p1);
    p+=MULTIPLICITY;
  }
  return GSL_SUCCESS;
}


int FUNCTION (gsl_matrix, apply_d) ( TYPE(gsl_matrix) *m, void *f ( BASE * , double), double p1 ) {
  int i, max= m->size2 * m->size1;
  ATOMIC *p=m->data;
  
  for(i=0;i<max;i++) {
    (*f)((BASE *)p,p1);
    p+=MULTIPLICITY;
  }
  return GSL_SUCCESS;
}

int FUNCTION (gsl_matrix, apply_dd) ( TYPE(gsl_matrix) *m, void *f ( BASE *, double, double), double p1, double p2) {
  int i, max= m->size2 * m->size1;
  ATOMIC *p=m->data;
  
  for(i=0;i<max;i++) {
    (*f)((BASE *)p,p1,p2);
    p+=MULTIPLICITY;
  }
  return GSL_SUCCESS;
}

int FUNCTION (gsl_matrix, apply_ij) ( TYPE(gsl_matrix) *m, void *f ( BASE *, int, int) ) {
  int i,j, maxi= m->size1, maxj=m->size2;
  ATOMIC *p=m->data;
  
  for(i=0;i<maxi;i++) 
    for (j=0;j<maxj;j++){
      (*f)((BASE *)p,i,j);
      p+=MULTIPLICITY;
    }
  return GSL_SUCCESS;
}


int FUNCTION (gsl_matrix, apply_ptr) ( TYPE(gsl_matrix) *m, void *f ( BASE *, void*), void *p1) {
  int i, max= m->size2 * m->size1;
  ATOMIC *p=m->data;
  
  for(i=0;i<max;i++) {
    (*f)((BASE *)p,p1);
    p+=MULTIPLICITY;
  }
  return GSL_SUCCESS;
}


int FUNCTION (gsl_matrix, apply_2) ( TYPE(gsl_matrix) *m, TYPE(gsl_matrix) *m1, void *f ( BASE *, BASE * ) ) {
  int i, max= m->size2 * m->size1;
  ATOMIC *p=m->data;
  ATOMIC *t=m1->data;
  
  if ( (m->size1 != m1->size1) || (m->size2 != m1->size2) ) {
    GSL_ERROR("Matrixes dimensions doesn't match",GSL_EINVAL);
  }

  for(i=0;i<max;i++) {
    (*f)((BASE *)p,(BASE *)t);
    p+=MULTIPLICITY;
    t+=MULTIPLICITY;
  }
  return GSL_SUCCESS;
}





