

#include "image.h"
#include "cut.h"

#include <gsl_matrix_op.h>


int correct_rfftw(MATRIX *p) {
  int i,j,rsize2;

  rsize2= (p->size2/2-1)*2; /*BUG: funziona sole se e' pari yn*/

  for (j=rsize2;j<p->size2;j++)
    for (i=0;i<p->size1;i++) {
      REAL t;
      
      t=MATRIX_GET(p,i,rsize2-1);
      MATRIX_SET(p,i,j,t);
    }
  return 1;
}

int out_data(FILE *f, MATRIX *p) {
  int mi,mj,i,j;

  mi=p->size1;
  mj=(p->size2/2-1)*2;
  

  for(i=0;i<mi;i++)  
    for(j=0;j<mj;j++) {
      REAL t=MATRIX_GET(p,i,j);
      
      fwrite(&t,sizeof(REAL),1,f);
    }
  return 1;
}

int out_gray(FILE *f, MATRIX *p, int dontscale) {
  int mi,mj,i,j,dummy;
  double min,max,k;
  unsigned short b;
  
  mi=p->size1;
  mj=(p->size2/2-1)*2;
  
  fwrite(&mi,sizeof(int),1,f);
  fwrite(&mj,sizeof(int),1,f);
  
  if (dontscale) {
    min=0.0;
    k=1.0;
  }
  else {
    MATRIX_MINMAX(p,&min,&max,&dummy,&dummy,&dummy,&dummy);
    k=65535.0/(max-min);
  }
  
  for(j=0;j<mj;j++)
    for(i=0;i<mi;i++) {
      double t=MATRIX_GET(p,i,j);
      char b1,b2;
      
      b=(unsigned short) ( (t-min)*k );
      b1=* ( (char *) &b);                    /* NON PORTABLE !!!!!!*/
      b2=* ( ( (char *) &b ) + 1 ); 
      b=256*b1+b2; 
      fwrite(&b,sizeof(short),1,f);
    }
  return 1;
  
}
